program_name='MAseries_Demo'
(***********************************************************)
// CREATED BY JANUS TECHNOLOGY LTD
(***********************************************************)
define_device

dvTP            = 10001:1:1

vdvModule       = 33003:1:1

dvSWITCH  = 0:4:1  // IP 0:4:0   For Serial Comms currently unsupported by firmware.g. 5001:1:1

dvDEBUG         = 33399:1:1

define_constant

CMD_OUTPUT_1                              = 1
CMD_OUTPUT_2                              = 2
CMD_OUTPUT_3                              = 3
CMD_OUTPUT_4                              = 4
CMD_OUTPUT_5                              = 5
CMD_OUTPUT_6                              = 6
CMD_OUTPUT_7                              = 7
CMD_OUTPUT_8                              = 8


CMD_INPUT_1                              = 21
CMD_INPUT_2                              = 22
CMD_INPUT_3                              = 23
CMD_INPUT_4                              = 24
CMD_INPUT_5                              = 25
CMD_INPUT_6                              = 26
CMD_INPUT_7                              = 27
CMD_INPUT_8                              = 28

// Special number 0 for OFF
CMD_INPUT_0                              = 29


CMD_MATRIX_ON = 71
CMD_MATRIX_OFF = 72
CMD_MATRIX_STANDBY = 73

TP_STATUS = 119
TP_VERSION = 101
TP_MODEL = 102

CMD_LOAD_PRESET_1 = 110
CMD_LOAD_PRESET_2 = 111
CMD_LOAD_PRESET_3 = 112
CMD_LOAD_PRESET_4 = 113
CMD_LOAD_PRESET_5 = 114
CMD_LOAD_PRESET_6 = 115
CMD_LOAD_PRESET_7 = 116
CMD_LOAD_PRESET_8 = 117

CMD_STORE_PRESET_1 = 121
CMD_STORE_PRESET_2 = 122
CMD_STORE_PRESET_3 = 123
CMD_STORE_PRESET_4 = 124
CMD_STORE_PRESET_5 = 125
CMD_STORE_PRESET_6 = 126
CMD_STORE_PRESET_7 = 127
CMD_STORE_PRESET_8 = 128


(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
define_variable

constant integer PRESET_LOAD_CMD_NUMBERS[] = 
{
  CMD_LOAD_PRESET_1,   
  CMD_LOAD_PRESET_2,   
  CMD_LOAD_PRESET_3,   
  CMD_LOAD_PRESET_4,
  CMD_LOAD_PRESET_5,   
  CMD_LOAD_PRESET_6,   
  CMD_LOAD_PRESET_7,   
  CMD_LOAD_PRESET_8
};

constant integer PRESET_STORE_CMD_NUMBERS[] = 
{
  CMD_STORE_PRESET_1,   
  CMD_STORE_PRESET_2,   
  CMD_STORE_PRESET_3,   
  CMD_STORE_PRESET_4,
  CMD_STORE_PRESET_5,   
  CMD_STORE_PRESET_6,   
  CMD_STORE_PRESET_7,   
  CMD_STORE_PRESET_8
};

constant integer MATRIX_CMD_NUMBERS[] = 
{
  CMD_MATRIX_ON,   
  CMD_MATRIX_OFF,   
  CMD_MATRIX_STANDBY
};

constant char MATRIX_CMDS[][255] = 
{
  'ON',   
  'OFF',   
  'STANDBY'
};


constant integer OUTPUT_NUMBERS[] = 
{
  CMD_OUTPUT_1,   
  CMD_OUTPUT_2,   
  CMD_OUTPUT_3,   
  CMD_OUTPUT_4,
  CMD_OUTPUT_5,               
  CMD_OUTPUT_6,   
  CMD_OUTPUT_7,  
  CMD_OUTPUT_8
};

constant integer INPUT_NUMBERS[] = 
{
  CMD_INPUT_0,
  CMD_INPUT_1,   
  CMD_INPUT_2,   
  CMD_INPUT_3,   
  CMD_INPUT_4,
  CMD_INPUT_5,               
  CMD_INPUT_6,   
  CMD_INPUT_7,
  CMD_INPUT_8   
};


char g_buffer[256];
dev g_vdvCurrentModel = vdvModule;

char IP_MA[15] = '172.16.106.52';  
char USERNAME[50] = 'admin'; 
char PASSWORD[50] = '123';  


define_module

define_module 'HDMI_MATRIX'  MA( vdvModule, dvSWITCH, IP_MA, USERNAME, PASSWORD);

define_start
{

}
(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
define_event

data_event[dvTP]
{
  online:
  {
    send_command g_vdvCurrentModel, "'GET_MODULE_VERSION '";
  }
}

button_event[dvTP, OUTPUT_NUMBERS]
{
  push:
  {
    integer but;
  
    but = get_last( OUTPUT_NUMBERS );
    send_command dvTP, "'^BCF-',itoa( OUTPUT_NUMBERS[but] ),',1,#000748FF'";
    if (g_buffer != "")
      g_buffer = "g_buffer,',',itoa( but )";
    else 
      g_buffer = "itoa( but )";
  }
}

button_event[dvTP, PRESET_LOAD_CMD_NUMBERS]
{
  push:
  {
    integer but;
    but = get_last( PRESET_LOAD_CMD_NUMBERS );
    send_command g_vdvCurrentModel,"'LOAD_PRESET ',itoa( but ),';' ";
  }
}

button_event[dvTP, PRESET_STORE_CMD_NUMBERS]
{
  push:
  {
    integer but;
    but = get_last( PRESET_STORE_CMD_NUMBERS );
    send_command g_vdvCurrentModel,"'STORE_PRESET ',itoa( but ),';' ";
  }
}

button_event[dvTP, MATRIX_CMD_NUMBERS]
{
  push:
  {
    integer but;
    but = get_last( MATRIX_CMD_NUMBERS );
    send_command g_vdvCurrentModel," MATRIX_CMDS[but],' ;' ";
  }
}

button_event[dvTP, INPUT_NUMBERS]
{
  push:
  {
    integer but;
    integer butTextFeedBack;
    integer count;
    char cJunk[3];
    
    but = get_last( INPUT_NUMBERS ) - 1;
    send_command g_vdvCurrentModel,"'SW ',g_buffer,'=',itoa( but ),';' ";
    
    count = 1; 
    while (count != 0)
    {
      count  = find_string ( g_buffer, ',', 1 );	
      cJunk = remove_string( g_buffer, ',', 1 );
      cJunk = left_string( cJunk, (length_string( cJunk ) - 1) );
      if (cjunk == "")
        cJunk = g_buffer;
      send_command dvTP, "'^TXT-',cJunk,',0,',itoa( but )";
      send_command dvTP, "'^BCF-',cJunk,',1,#0216CDFF'";
    }
    g_buffer = "";
  }
}

data_event[g_vdvCurrentModel]
{
  string:
  {
	char cmdHeader[30], 
		 value[100],
		 cmd[100], 
		 statusType[3], 
		 fbOutput[3], 
		 fbInput[3];
	
	while (find_string( data.text, ';',  1 ) > 0)
	{
	  cmd = remove_string( data.text, ';', 1 );
	  cmdHeader = remove_string( cmd, ' ', 1 );
	  value = left_string( cmd, length_string( cmd ) - 1);
	  switch (cmdHeader)
	  {
		case 'SW ':
		{
		  fbOutput = remove_string( value, '=', 1 );
		  fbOutput = left_string( fbOutput, (length_string( fbOutput ) - 1) );
		  fbInput = value;
		 
		  //fbInput = left_string( fbInput, (length_string( fbInput ) - 1) );
		  if (fbInput != "" || fbOutput != "")
			send_command dvTP, "'^TXT-',fbOutput,',0,',fbInput";
		}
		case 'MODEL ':
		{
		    send_command dvTP, "'^TXT-',itoa( TP_MODEL ),',0,',value"
		}
		
		case 'VERSION ':
		{
		  send_command dvTP, "'^TXT-',itoa( TP_VERSION ),',0,',value";
		}
		
		
		case 'STATUS ':
		{
		  statusType = remove_string( value, '=', 1 );
		  statusType = left_string( statusType, length_string( statusType ) - 1);
		  if (statusType == '1')
		    Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF GREEN'";  
		  else if (statusType == '2')
		    Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF ORANGE'";  
		  else if (statusType == '3')
		    Send_Command dvTP, "'^BMF-',ItoA( TP_STATUS ),',0,%CF RED'";  
		  
		  send_command dvTP, "'^TXT-',itoa( TP_STATUS ),',0,',value";
		}
		
		// Have to display version of SW. // GET_VERSION
		default :
		{
		}
	  }
	}
  }
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
define_program


